﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;

namespace testXamComboMulti
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        ObservableCollection<FieldSortDescription> fsdc = new ObservableCollection<FieldSortDescription>();
        bool groupby = false;
        object preveselected;
        public Window1()
        {
            InitializeComponent();
            ComboBoxItemsProvider c = new ComboBoxItemsProvider();
            ComboBoxDataItem cb = new ComboBoxDataItem();
            cb.Value = MyClass.CreateData();
            c.Items.Add(cb);
            xamComboEditor1.ItemsProvider = c;

        }

        private void PART_FocusSite_SelectedItemsChanging(object sender, Infragistics.Windows.DataPresenter.Events.SelectedItemsChangingEventArgs e)
        {
            if (groupby)
            {
                groupby = false;
                xamComboEditor1.IsDropDownOpen = true;
                return;
            }
         //   XamComboEditor x = Infragistics.Windows.Utilities.GetAncestorFromType(sender as XamDataGrid, typeof(XamComboEditor), false) as XamComboEditor;
            XamComboEditor x = xamComboEditor1;
            SelectedRecordCollection c =  e.NewSelection.Records;
            if (c == null || c.Count == 0)
                return;
            if (c[0] is DataRecord)
            {
                x.Value = (c[0] as DataRecord).Cells[0].Value.ToString();
                x.EndEditMode(true, true);
            }
        }

        private void TextBlock_Grouped_1(object sender, Infragistics.Windows.DataPresenter.Events.GroupedEventArgs e)
        {
         //   xamComboEditor1.SelectedItem = null;
         //   xamComboEditor1.IsDropDownOpen = true;
            fsdc.Clear();
            foreach (FieldSortDescription fsd in e.FieldLayout.SortedFields)
            {
                FieldSortDescription fsdnew = new FieldSortDescription();
                fsdnew.Direction = fsd.Direction;
                fsdnew.Field = fsd.Field;
                fsdnew.FieldName = fsd.FieldName;
                fsdnew.IsGroupBy = fsd.IsGroupBy;
                fsdc.Add(fsdnew);

            }
            e.Handled = true;
            xamComboEditor1.IsDropDownOpen = true;
              
          
           
        }

        private void xamComboEditor1_SelectedItemChanged_1(object sender, RoutedPropertyChangedEventArgs<object> e)
        {

            if (groupby)
            {
                xamComboEditor1.SelectedItem = preveselected;
                groupby = false;
            }
         //   else preveselected = xamComboEditor1.SelectedItem;
        }

        private void TextBlock_Grouping_1(object sender, Infragistics.Windows.DataPresenter.Events.GroupingEventArgs e)
        {
            groupby = true;
            preveselected = xamComboEditor1.SelectedItem;
        }

        private void TextBlock_Loaded_1(object sender, RoutedEventArgs e)
        {
           
        }

        private void TextBlock_Unloaded_1(object sender, RoutedEventArgs e)
        {
            //XamDataGrid xdg = sender as XamDataGrid;
            //fsdc.Clear();
            //foreach (FieldSortDescription fsd in xdg.FieldLayouts[0].SortedFields)
            //{
            //    FieldSortDescription fsdnew = new FieldSortDescription();
            //    fsdnew.Direction = fsd.Direction;
            //    fsdnew.Field = fsd.Field;
            //    fsdnew.FieldName = fsd.FieldName;
            //    fsdnew.IsGroupBy = fsd.IsGroupBy;
            //    fsdc.Add(fsdnew);

            //}
        }

        private void TextBlock_FieldLayoutInitialized_1(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            XamDataGrid xdg = sender as XamDataGrid;
          //  xdg.FieldLayouts[0].SortedFields.Clear();
            e.FieldLayout.SortedFields.Clear();
            foreach (FieldSortDescription fsd in fsdc)
            {
                FieldSortDescription fsdnew = new FieldSortDescription();
                fsdnew.Direction = fsd.Direction;
            //    fsdnew.Field = fsd.Field;
                fsdnew.FieldName = fsd.FieldName;
                fsdnew.IsGroupBy = fsd.IsGroupBy;
              //  xdg.FieldLayouts[0].SortedFields.Add(fsdnew);
                e.FieldLayout.SortedFields.Add(fsdnew);
            }
        }

        private void TextBlock_MouseUp_1(object sender, MouseButtonEventArgs e)
        {
            e.Handled = true;
            groupby = false;

        }

        private void Window_PreviewMouseUp_1(object sender, MouseButtonEventArgs e)
        {
           // e.Handled = true;
        }
    }
    public class MyClass
    {
        public string Name { get; set; }
        public int Age { get; set; }
        public string Description { get; set; }
        public MyClass() 
        {
            this.Name = "new Name";
            this.Age = 0;
            this.Description = "N/A";
        }
        public static List<MyClass> CreateData()
        {
            List<MyClass> data = new List<MyClass>();
            for (int i = 0; i < 5; i++)
            {
                data.Add(new MyClass() { Age = i, Name = "Name " + i.ToString() });
            }


            return data;
        }
    }
}
